#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 2 "./config_parse.y"
/*
 * The Spread Toolkit.
 *     
 * The contents of this file are subject to the Spread Open-Source
 * License, Version 1.0 (the ``License''); you may not use
 * this file except in compliance with the License.  You may obtain a
 * copy of the License at:
 *
 * http://www.spread.org/license/
 *
 * or in the file ``license.txt'' found in this distribution.
 *
 * Software distributed under the License is distributed on an AS IS basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License.
 *
 * The Creators of Spread are:
 *  Yair Amir, Michal Miskin-Amir, Jonathan Stanton.
 *
 *  Copyright (C) 1993-2002 Spread Concepts LLC <spread@spreadconcepts.com>
 *
 *  All Rights Reserved.
 *
 * Major Contributor(s):
 * ---------------
 *    Cristina Nita-Rotaru crisn@cnds.jhu.edu - group communication security.
 *    Theo Schlossnagle    jesus@omniti.com - Perl, skiplists, autoconf.
 *    Dan Schoenblum       dansch@cnds.jhu.edu - Java interface.
 *    John Schultz         jschultz@cnds.jhu.edu - contribution to process group membership.
 *
 */


#include "arch.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef ARCH_PC_WIN95
#include <sys/types.h>
#include <netdb.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <sys/param.h>

#else /* ARCH_PC_WIN95 */
#include <winsock.h>
#endif /* ARCH_PC_WIN95 */

#include "alarm.h"
#include "configuration.h"
#include "skiplist.h"
#include "memory.h"
#include "objects.h"
#include "conf_body.h"
#include "acm.h"

        int     line_num, semantic_errors;
 extern char    *yytext;
 extern int     yyerror(char *str);
 extern void    yywarn(char *str);
 extern int     yylex();

 static int     num_procs = 0;
 static int     segment_procs = 0;
 static int     segments = 0;
 static int     rvec_num = 0;
 static int     procs_interfaces = 0;

 static int     authentication_configured = 0;

static char *segment2str(int seg) {
  static char ipstr[40];
  int id = Config.segments[seg].bcast_address;
  sprintf(ipstr, "%d.%d.%d.%d:%d",
  	(id & 0xff000000)>>24,
  	(id & 0xff0000)>>16,
  	(id & 0xff00)>>8,
  	(id & 0xff),
	Config.segments[seg].port);
  return ipstr;
}
static void alarm_print_proc(proc *p, int port) {
  if(port == p->port)
    Alarm(CONF, "\t%20s: %d.%d.%d.%d\n", p->name,
  	  (p->id & 0xff000000)>>24,
  	  (p->id & 0xff0000)>>16,
  	  (p->id & 0xff00)>>8,
  	  (p->id & 0xff));
  else
    Alarm(CONF, "\t%20s: %d.%d.%d.%d:%d\n", p->name,
  	  (p->id & 0xff000000)>>24,
  	  (p->id & 0xff0000)>>16,
  	  (p->id & 0xff00)>>8,
  	  (p->id & 0xff),
	  p->port);
}

static int32u name2ip(char *name) {
  int anip, i1, i2, i3, i4;
  struct hostent *host_ptr;

  host_ptr = gethostbyname(name);
  
  if ( host_ptr == 0)
    Alarm( EXIT, "Conf_init: no such host %s\n",
	   name);
  
  memcpy(&anip, host_ptr->h_addr_list[0], 
	 sizeof(int32) );
  anip = htonl( anip );
  i1= ( anip & 0xff000000 ) >> 24;
  i2= ( anip & 0x00ff0000 ) >> 16;
  i3= ( anip & 0x0000ff00 ) >>  8;
  i4=   anip & 0x000000ff;
  return ((i1<<24)|(i2<<16)|(i3<<8)|i4);
}

static  void expand_filename(char *out_string, int str_size, const char *in_string)
{
  const char *in_loc;
  char *out_loc;
  char hostn[256];
  
  for ( in_loc = in_string, out_loc = out_string; out_loc - out_string < str_size; in_loc++ )
  {
          if (*in_loc == '%' ) {
                  switch( in_loc[1] ) {
                  case 'h':
                  case 'H':
                          gethostname(hostn, sizeof(hostn) );
                          out_loc += snprintf(out_loc, str_size - (out_loc - out_string), "%s", hostn); 
                          in_loc++;
                          continue;
                  default:
                          break;
                  }

          }
          *out_loc = *in_loc;
          out_loc++;
          if (*in_loc == '\0') break;
  }
  out_string[str_size-1] = '\0';
}

#define PROCS_CHECK( num_procs, stoken ) { \
                                            char strbuf[80]; \
                                            if ( (num_procs) >= MAX_PROCS_RING ) { \
                                                snprintf(strbuf, 80, "%s (Too many daemons configured--%d max)\n", (stoken), MAX_PROCS_RING); \
                                                return (yyerror(strbuf)); \
                                            } \
                                         }
#define SEGMENT_CHECK( num_segments, stoken )  { \
                                            char strbuf[80]; \
                                            if ( (num_segments) >= MAX_SEGMENTS ) { \
                                                snprintf(strbuf, 80, "%s (Too many segments configured--%d max)\n", (stoken), MAX_SEGMENTS); \
                                                return( yyerror(strbuf)); \
                                            } \
                                         }
#define SEGMENT_SIZE_CHECK( num_procs, stoken )  { \
                                            char strbuf[80]; \
                                            if ( (num_procs) >= MAX_PROCS_SEGMENT ) { \
                                                snprintf(strbuf, 80, "%s (Too many daemons configured in segment--%d max)\n", (stoken), MAX_PROCS_SEGMENT); \
                                                return( yyerror(strbuf)); \
                                            } \
                                         }
#define INTERFACE_NUM_CHECK( num_ifs, stoken )  { \
                                            char strbuf[80]; \
                                            if ( (num_ifs) >= MAX_INTERFACES_PROC ) { \
                                                snprintf(strbuf, 80, "%s (Too many interfaces configured in proc--%d max)\n", (stoken), MAX_INTERFACES_PROC); \
                                                return( yyerror(strbuf)); \
                                            } \
                                         }


#line 197 "y.tab.c"
#define YYERRCODE 256
#define SEGMENT 257
#define EVENTLOGFILE 258
#define EVENTTIMESTAMP 259
#define IPADDR 260
#define NUMBER 261
#define COLON 262
#define OPENBRACE 263
#define CLOSEBRACE 264
#define EQUALS 265
#define STRING 266
#define DEBUGFLAGS 267
#define BANG 268
#define DDEBUG 269
#define DEXIT 270
#define DPRINT 271
#define DDATA_LINK 272
#define DNETWORK 273
#define DPROTOCOL 274
#define DSESSION 275
#define DCONF 276
#define DMEMB 277
#define DFLOW_CONTROL 278
#define DSTATUS 279
#define DEVENTS 280
#define DGROUPS 281
#define DMEMORY 282
#define DSKIPLIST 283
#define DACM 284
#define DALL 285
#define DNONE 286
#define DANGEROUSMONITOR 287
#define SOCKETPORTREUSE 288
#define RUNTIMEDIR 289
#define SPUSER 290
#define SPGROUP 291
#define ALLOWEDAUTHMETHODS 292
#define REQUIREDAUTHMETHODS 293
#define ACCESSCONTROLPOLICY 294
#define SP_BOOL 295
#define SP_TRIVAL 296
#define LINKPROTOCOL 297
#define PHOP 298
#define PTCPHOP 299
#define IMONITOR 300
#define ICLIENT 301
#define IDAEMON 302
#define ROUTEMATRIX 303
#define LINKCOST 304
const short yylhs[] = {                                        -1,
    0,    1,    1,    1,    1,    5,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    5,    5,    5,    5,
    5,    5,    5,    6,    6,    6,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    2,    7,    7,    8,    8,    8,    8,   10,   10,   10,
   11,   11,    9,    9,   12,    4,   13,   13,   14,   14,
};
const short yylen[] = {                                         2,
    1,    2,    2,    2,    0,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    3,    0,    5,    3,    3,    1,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    5,    2,    0,    5,    4,    2,    1,    1,    1,    1,
    2,    0,    2,    0,    2,    4,    2,    0,    1,    0,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    1,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   58,    2,    3,    4,    0,   28,   29,   26,
   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
    0,    0,    0,    0,    0,   56,   59,   57,    0,    0,
   41,   42,   27,    0,    6,    7,    8,    9,   10,   11,
   12,   13,   14,   15,   16,   17,   18,   19,   20,   21,
   22,   23,   24,    0,    0,    0,    0,   25,    0,   45,
   55,   48,   49,   50,   51,   53,   44,
};
const short yydgoto[] = {                                      15,
   16,   17,   18,   19,   83,   55,   53,   54,   85,   95,
   86,   87,   51,   58,
};
const short yysindex[] = {                                   -255,
 -254, -247, -240, -239, -238, -237, -236, -235, -234, -224,
 -222, -221, -220, -252,    0,    0, -255, -255, -255, -217,
 -219, -214, -169, -200, -199, -170, -168, -167, -166, -165,
 -164, -275,    0,    0,    0,    0, -163,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -264, -253, -160, -163, -211,    0,    0,    0, -158,    0,
    0,    0,    0, -193,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -157, -246,    0,    0, -156,    0,
    0,    0,    0,    0,    0,    0,    0,
};
const short yyrindex[] = {                                    106,
    0,    0,    1,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  106,  106,  106,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -155,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -245,    0, -155,    0,    0,    0,    0, -244, -251,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -251,    0,    0, -251,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
   -2,    0,    0,    0,   46,    0,   57,    0,  -79,    0,
    0,    0,    0,    0,
};
#define YYTABLESIZE 304
const short yytable[] = {                                      56,
   30,    1,    2,    3,   89,   20,   59,   96,   52,   60,
   33,    4,   54,   91,   34,   35,   36,   21,   47,   46,
   47,   46,   49,   50,   22,   23,   24,   25,   26,   27,
   28,    5,    6,    7,    8,    9,   10,   11,   12,   57,
   29,   13,   30,   31,   32,   37,   38,   14,   52,   52,
   52,   39,   63,   92,   93,   94,   64,   65,   66,   67,
   68,   69,   70,   71,   72,   73,   74,   75,   76,   77,
   78,   79,   80,   81,   82,   65,   66,   67,   68,   69,
   70,   71,   72,   73,   74,   75,   76,   77,   78,   79,
   80,   81,   82,   40,   41,   43,   42,   44,   45,   46,
   47,   48,   52,   61,   84,    5,   90,   97,   43,   88,
   62,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   30,   30,   30,
    0,    0,    0,    0,    0,    0,    0,   30,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   30,   30,   30,
   30,   30,   30,   30,   30,    0,    0,   30,    0,    0,
    0,    0,    0,   30,
};
const short yycheck[] = {                                     264,
    0,  257,  258,  259,   84,  260,  260,   87,  260,  263,
  263,  267,  264,  260,   17,   18,   19,  265,  264,  264,
  266,  266,  298,  299,  265,  265,  265,  265,  265,  265,
  265,  287,  288,  289,  290,  291,  292,  293,  294,  304,
  265,  297,  265,  265,  265,  263,  266,  303,  300,  301,
  302,  266,  264,  300,  301,  302,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  263,  295,  266,  296,  266,  266,  266,
  266,  266,  266,  264,  263,    0,  264,  264,  264,   64,
   54,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  287,  288,  289,
  290,  291,  292,  293,  294,   -1,   -1,  297,   -1,   -1,
   -1,   -1,   -1,  303,
};
#define YYFINAL 15
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 304
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"SEGMENT","EVENTLOGFILE",
"EVENTTIMESTAMP","IPADDR","NUMBER","COLON","OPENBRACE","CLOSEBRACE","EQUALS",
"STRING","DEBUGFLAGS","BANG","DDEBUG","DEXIT","DPRINT","DDATA_LINK","DNETWORK",
"DPROTOCOL","DSESSION","DCONF","DMEMB","DFLOW_CONTROL","DSTATUS","DEVENTS",
"DGROUPS","DMEMORY","DSKIPLIST","DACM","DALL","DNONE","DANGEROUSMONITOR",
"SOCKETPORTREUSE","RUNTIMEDIR","SPUSER","SPGROUP","ALLOWEDAUTHMETHODS",
"REQUIREDAUTHMETHODS","ACCESSCONTROLPOLICY","SP_BOOL","SP_TRIVAL",
"LINKPROTOCOL","PHOP","PTCPHOP","IMONITOR","ICLIENT","IDAEMON","ROUTEMATRIX",
"LINKCOST",
};
const char * const yyrule[] = {
"$accept : Config",
"Config : ConfigStructs",
"ConfigStructs : SegmentStruct ConfigStructs",
"ConfigStructs : ParamStruct ConfigStructs",
"ConfigStructs : RouteStruct ConfigStructs",
"ConfigStructs :",
"AlarmBit : DDEBUG",
"AlarmBit : DEXIT",
"AlarmBit : DPRINT",
"AlarmBit : DDATA_LINK",
"AlarmBit : DNETWORK",
"AlarmBit : DPROTOCOL",
"AlarmBit : DSESSION",
"AlarmBit : DCONF",
"AlarmBit : DMEMB",
"AlarmBit : DFLOW_CONTROL",
"AlarmBit : DSTATUS",
"AlarmBit : DEVENTS",
"AlarmBit : DGROUPS",
"AlarmBit : DMEMORY",
"AlarmBit : DSKIPLIST",
"AlarmBit : DACM",
"AlarmBit : DALL",
"AlarmBit : DNONE",
"AlarmBitComp : AlarmBitComp AlarmBit",
"AlarmBitComp : AlarmBitComp BANG AlarmBit",
"AlarmBitComp :",
"ParamStruct : DEBUGFLAGS EQUALS OPENBRACE AlarmBitComp CLOSEBRACE",
"ParamStruct : EVENTLOGFILE EQUALS STRING",
"ParamStruct : EVENTTIMESTAMP EQUALS STRING",
"ParamStruct : EVENTTIMESTAMP",
"ParamStruct : DANGEROUSMONITOR EQUALS SP_BOOL",
"ParamStruct : SOCKETPORTREUSE EQUALS SP_TRIVAL",
"ParamStruct : RUNTIMEDIR EQUALS STRING",
"ParamStruct : SPUSER EQUALS STRING",
"ParamStruct : SPGROUP EQUALS STRING",
"ParamStruct : ALLOWEDAUTHMETHODS EQUALS STRING",
"ParamStruct : REQUIREDAUTHMETHODS EQUALS STRING",
"ParamStruct : ACCESSCONTROLPOLICY EQUALS STRING",
"ParamStruct : LINKPROTOCOL EQUALS PHOP",
"ParamStruct : LINKPROTOCOL EQUALS PTCPHOP",
"SegmentStruct : SEGMENT IPADDR OPENBRACE Segmentparams CLOSEBRACE",
"Segmentparams : Segmentparam Segmentparams",
"Segmentparams :",
"Segmentparam : STRING IPADDR OPENBRACE Interfaceparams CLOSEBRACE",
"Segmentparam : STRING OPENBRACE Interfaceparams CLOSEBRACE",
"Segmentparam : STRING IPADDR",
"Segmentparam : STRING",
"IfType : IMONITOR",
"IfType : ICLIENT",
"IfType : IDAEMON",
"IfTypeComp : IfTypeComp IfType",
"IfTypeComp :",
"Interfaceparams : Interfaceparam Interfaceparams",
"Interfaceparams :",
"Interfaceparam : IfTypeComp IPADDR",
"RouteStruct : ROUTEMATRIX OPENBRACE Routevectors CLOSEBRACE",
"Routevectors : Routevectors Routevector",
"Routevectors :",
"Routevector : LINKCOST",
"Routevector :",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
#line 536 "./config_parse.y"
void yywarn(char *str) {
        fprintf(stderr, "-------Parse Warning-----------\n");
        fprintf(stderr, "Parser warning on or before line %d\n", line_num);
        fprintf(stderr, "Error type; %s\n", str);
        fprintf(stderr, "Offending token: %s\n", yytext);
}
int yyerror(char *str) {
  fprintf(stderr, "-------------------------------------------\n");
  fprintf(stderr, "Parser error on or before line %d\n", line_num);
  fprintf(stderr, "Error type; %s\n", str);
  fprintf(stderr, "Offending token: %s\n", yytext);
  exit(1);
}
#line 505 "y.tab.c"
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 195 "./config_parse.y"
{
			  Config.num_segments = segments;
			  Num_procs = num_procs;
			  Alarm(CONF, "Finished configuration file.\n");
			}
break;
case 6:
#line 208 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 7:
#line 209 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 8:
#line 210 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 9:
#line 211 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 10:
#line 212 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 11:
#line 213 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 12:
#line 214 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 13:
#line 215 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 14:
#line 216 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 15:
#line 217 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 16:
#line 218 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 17:
#line 219 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 18:
#line 220 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 19:
#line 221 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 20:
#line 222 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 21:
#line 223 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 22:
#line 224 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 23:
#line 225 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 24:
#line 229 "./config_parse.y"
{
			  yyval.mask = (yyvsp[-1].mask | yyvsp[0].mask);
			}
break;
case 25:
#line 233 "./config_parse.y"
{
			  yyval.mask = (yyvsp[-2].mask & ~(yyvsp[0].mask));
			}
break;
case 26:
#line 236 "./config_parse.y"
{ yyval.mask = NONE; }
break;
case 27:
#line 240 "./config_parse.y"
{
			  if (! Alarm_get_interactive() ) {
                            Alarm_clear(ALL);
			    Alarm_set(yyvsp[-1].mask);
			    Alarm(CONF, "Set Alarm mask to: %x\n", Alarm_get());
                          }
			}
break;
case 28:
#line 248 "./config_parse.y"
{
			  if (! Alarm_get_interactive() ) {
                            char file_buf[MAXPATHLEN];
                            expand_filename(file_buf, MAXPATHLEN, yyvsp[0].string);
                            Alarm_set_output(file_buf);
                          }
			}
break;
case 29:
#line 256 "./config_parse.y"
{
			  if (! Alarm_get_interactive() ) {
			    Alarm_enable_timestamp(yyvsp[0].string);
                          }
			}
break;
case 30:
#line 262 "./config_parse.y"
{
			  if (! Alarm_get_interactive() ) {
			    Alarm_enable_timestamp(NULL);
                          }
			}
break;
case 31:
#line 268 "./config_parse.y"
{
			  if (! Alarm_get_interactive() ) {
                            Conf_set_dangerous_monitor_state(yyvsp[0].boolean);
                          }
			}
break;
case 32:
#line 274 "./config_parse.y"
{
                            port_reuse state;
                            if (yyvsp[0].number == 1)
                            {
                                state = port_reuse_on;
                            }
                            else if (yyvsp[0].number == 0)
                            {
                                state = port_reuse_off;
                            }
                            else
                            {
                                /* Default to AUTO. */
                                state = port_reuse_auto;
                            }
                            Conf_set_port_reuse_type(state);
                        }
break;
case 33:
#line 292 "./config_parse.y"
{
                            Conf_set_runtime_dir(yyvsp[0].string);
                        }
break;
case 34:
#line 296 "./config_parse.y"
{
                            Conf_set_user(yyvsp[0].string);
                        }
break;
case 35:
#line 300 "./config_parse.y"
{
                            Conf_set_group(yyvsp[0].string);
                        }
break;
case 36:
#line 304 "./config_parse.y"
{
                            char auth_list[MAX_AUTH_LIST_LEN];
                            int i, len;
                            char *c_ptr;
                            if (!authentication_configured) {
                                Acm_auth_set_disabled("NULL");
                            }
                            authentication_configured = 1;

                            strncpy(auth_list, yyvsp[0].string, MAX_AUTH_LIST_LEN);
                            len = strlen(auth_list); 
                            for (i=0; i < len; )
                            {
                                c_ptr = strchr(&auth_list[i], ' ');
                                if (c_ptr != NULL)
                                {
                                    *c_ptr = '\0';
                                }
                                Acm_auth_set_enabled(&auth_list[i]);    
                                i += strlen(&auth_list[i]);
                                i++; /* for null */
                            }
                        }
break;
case 37:
#line 328 "./config_parse.y"
{
                            char auth_list[MAX_AUTH_LIST_LEN];
                            int i, len;
                            char *c_ptr;
                            if (!authentication_configured) {
                                Acm_auth_set_disabled("NULL");
                            }
                            authentication_configured = 1;

                            strncpy(auth_list, yyvsp[0].string, MAX_AUTH_LIST_LEN);
                            len = strlen(auth_list); 
                            for (i=0; i < len; )
                            {
                                c_ptr = strchr(&auth_list[i], ' ');
                                if (c_ptr != NULL)
                                {
                                    *c_ptr = '\0';
                                } 
                                Acm_auth_set_required(&auth_list[i]);    
                                i += strlen(&auth_list[i]);
                                i++; /* for null */
                            }
                        }
break;
case 38:
#line 352 "./config_parse.y"
{
                            int ret;
                            ret = Acm_acp_set_policy(yyvsp[0].string);
                            if (!ret)
                            {
                                    yyerror("Invalid Access Control Policy name. Make sure it is spelled right and any needed mocdules are loaded");
                            }
                        }
break;
case 39:
#line 361 "./config_parse.y"
{
                            Conf_set_link_protocol(HOP_PROT);
			}
break;
case 40:
#line 365 "./config_parse.y"
{
                            Conf_set_link_protocol(TCP_PROT);
			}
break;
case 41:
#line 370 "./config_parse.y"
{ int i;
                          SEGMENT_CHECK( segments, inet_ntoa(yyvsp[-3].ip.addr) );
			  Config.segments[segments].num_procs = segment_procs;
			  Config.segments[segments].port = yyvsp[-3].ip.port;
			  Config.segments[segments].bcast_address =
			    yyvsp[-3].ip.addr.s_addr;
			  if(Config.segments[segments].port == 0)
			    Config.segments[segments].port = DEFAULT_SPREAD_PORT;
			  Alarm(CONF, "Successfully configured Segment %d [%s] with %d procs:\n",
				segments,
				segment2str(segments),
				segment_procs);
			  for(i=(num_procs - segment_procs); i<num_procs; i++) {
                                  /* This '1' is to keep each proc with the same port as the segment.*/
			    if( 1 || Config_procs[i].port==0)  {
			      Config_procs[i].port=
				Config.segments[segments].port;
			    }
			    alarm_print_proc(&Config_procs[i],
			    	Config.segments[segments].port);
			  }
			  segments++;
			  segment_procs = 0;
			}
break;
case 44:
#line 401 "./config_parse.y"
{ 
                          PROCS_CHECK( num_procs, yyvsp[-4].string );
                          SEGMENT_CHECK( segments, yyvsp[-4].string );
                          SEGMENT_SIZE_CHECK( segment_procs, yyvsp[-4].string );
                          if (procs_interfaces == 0)
                                  yyerror("Interfaces section declared but no actual interface addresses defined\n");
                          strcpy(Config_procs[num_procs].name, yyvsp[-4].string);
                          Config_procs[num_procs].id = yyvsp[-3].ip.addr.s_addr;
 		          Config_procs[num_procs].port = yyvsp[-3].ip.port;
			  Config_procs[num_procs].seg_index = segments;
			  Config_procs[num_procs].index_in_seg = segment_procs;
                          Config_procs[num_procs].num_if = procs_interfaces;
			  Config.segments[segments].procs[segment_procs] = 
                                  &Config_procs[num_procs];
			  num_procs++;
			  segment_procs++;
                          procs_interfaces = 0;
			}
break;
case 45:
#line 420 "./config_parse.y"
{ 
                          PROCS_CHECK( num_procs, yyvsp[-3].string );
                          SEGMENT_CHECK( segments, yyvsp[-3].string );
                          SEGMENT_SIZE_CHECK( segment_procs, yyvsp[-3].string );
                          if (procs_interfaces == 0)
                                  yyerror("Interfaces section declared but no actual interface addresses defined\n");
                          strcpy(Config_procs[num_procs].name, yyvsp[-3].string);
                          Config_procs[num_procs].id =
			    name2ip(Config_procs[num_procs].name);
 		          Config_procs[num_procs].port = 0;
			  Config_procs[num_procs].seg_index = segments;
			  Config_procs[num_procs].index_in_seg = segment_procs;
                          Config_procs[num_procs].num_if = procs_interfaces;
			  Config.segments[segments].procs[segment_procs] = 
                                  &Config_procs[num_procs];
			  num_procs++;
			  segment_procs++;
                          procs_interfaces = 0;
			}
break;
case 46:
#line 440 "./config_parse.y"
{ 
                          PROCS_CHECK( num_procs, yyvsp[-1].string );
                          SEGMENT_CHECK( segments, yyvsp[-1].string );
                          SEGMENT_SIZE_CHECK( segment_procs, yyvsp[-1].string );
                          strcpy(Config_procs[num_procs].name, yyvsp[-1].string);
                          Config_procs[num_procs].id = yyvsp[0].ip.addr.s_addr;
 		          Config_procs[num_procs].port = yyvsp[0].ip.port;
			  Config_procs[num_procs].seg_index = segments;
			  Config_procs[num_procs].index_in_seg = segment_procs;
                          Config_procs[num_procs].num_if = 1;
                          Config_procs[num_procs].ifc[0].ip = Config_procs[num_procs].id;
                          Config_procs[num_procs].ifc[0].port = Config_procs[num_procs].port;
                          Config_procs[num_procs].ifc[0].type = IFTYPE_ALL | IFTYPE_ANY;
			  Config.segments[segments].procs[segment_procs] = 
                                  &Config_procs[num_procs];
			  num_procs++;
			  segment_procs++;
                          procs_interfaces = 0;
			}
break;
case 47:
#line 460 "./config_parse.y"
{ 
                          PROCS_CHECK( num_procs, yyvsp[0].string );
                          SEGMENT_CHECK( segments, yyvsp[0].string );
                          SEGMENT_SIZE_CHECK( segment_procs, yyvsp[0].string );
                          strcpy(Config_procs[num_procs].name, yyvsp[0].string);
                          Config_procs[num_procs].id =
			    name2ip(Config_procs[num_procs].name);
 		          Config_procs[num_procs].port = 0;
			  Config_procs[num_procs].seg_index = segments;
			  Config_procs[num_procs].index_in_seg = segment_procs;
                          Config_procs[num_procs].num_if = 1;
                          Config_procs[num_procs].ifc[0].ip = Config_procs[num_procs].id;
                          Config_procs[num_procs].ifc[0].port = Config_procs[num_procs].port;
                          Config_procs[num_procs].ifc[0].type = IFTYPE_ALL | IFTYPE_ANY;
			  Config.segments[segments].procs[segment_procs] = 
                                  &Config_procs[num_procs];
			  num_procs++;
			  segment_procs++;
                          procs_interfaces = 0;
			}
break;
case 48:
#line 482 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 49:
#line 483 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 50:
#line 484 "./config_parse.y"
{ yyval = yyvsp[0]; }
break;
case 51:
#line 488 "./config_parse.y"
{
			  yyval.mask = (yyvsp[-1].mask | yyvsp[0].mask);
			}
break;
case 52:
#line 491 "./config_parse.y"
{ yyval.mask = 0; }
break;
case 55:
#line 499 "./config_parse.y"
{ 
                          PROCS_CHECK( num_procs, yyvsp[-1].string );
                          SEGMENT_CHECK( segments, yyvsp[-1].string );
                          SEGMENT_SIZE_CHECK( segment_procs, yyvsp[-1].string );
                          INTERFACE_NUM_CHECK( procs_interfaces, yyvsp[-1].string );
                          Config_procs[num_procs].ifc[procs_interfaces].ip = yyvsp[0].ip.addr.s_addr;
                          Config_procs[num_procs].ifc[procs_interfaces].port = yyvsp[0].ip.port;
                          if (yyvsp[-1].mask == 0)
                                  Config_procs[num_procs].ifc[procs_interfaces].type = IFTYPE_ALL;
                          else 
                                  Config_procs[num_procs].ifc[procs_interfaces].type = yyvsp[-1].mask;
                          procs_interfaces++;
			}
break;
case 56:
#line 515 "./config_parse.y"
{ 
			  Alarm(CONF, "Successfully configured Routing Matrix for %d Segments with %d rows in the routing matrix\n",segments, rvec_num);
			}
break;
case 59:
#line 525 "./config_parse.y"
{ 
                                int rvec_element;
                                for (rvec_element = 0; rvec_element < segments; rvec_element++) {
                                        if (yyvsp[0].cost[rvec_element] < 0) yyerror("Wrong number of entries for routing matrix");
                                        LinkWeights[rvec_num][rvec_element] = yyvsp[0].cost[rvec_element];
                                }
                                rvec_num++;
                        }
break;
#line 1123 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
